#!/bin/bash

check_local_timezone() {
  dt=`date "+%H:%M" | grep "00:00"`
  if [[ -n ${dt} ]]; then
    # do sync time
    cp /usr/share/zoneinfo/Asia/Shanghai /etc/localtime
    ntpdate cn.pool.ntp.org
    hwclock --systohc
  fi
}

check_tools_status() {
    # check ntpdate
    exist=`whereis ntpdate | awk '{print $2}'`
    system=`cat /etc/issue |grep Ubuntu |wc -l`
    
    if [[ -z ${exist} ]]; then
       if [[ -z ${system} ]]; then
          yum install ntpdate -y
       else
          apt-get install ntpdate -y
       fi
    fi

    # check smartctl
    exist2=`whereis smartctl | awk '{print $2}'`

    if [[ -z ${exist2} ]]; then
       if [[ -z ${system} ]]; then
          yum install smartmontools -y
       else
          apt-get install smartmontools -y
       fi
    fi
}

stop_all_groum_Guarded_by_pear_restart()
{
  conf_file="/etc/pear/pear_restart/pids.conf"
  if [ -f ${conf_file} ]; then
    cat ${conf_file} | while read line
    do
      if [ -n "${line}" ]; then
        pid=$(echo ${line} | awk '{print $2}')
        if [ -n "${pid}" ]; then
          kill -SIGTERM ${pid}
        fi
      fi
    done
  fi
  echo '' > ${conf_file}
}

start_app() {
  /etc/pear/pear_scripts/replace.sh
  check_local_timezone
  check_tools_status
  /usr/sbin/pear_restart --install_path=/ &
  # nohup /root/pear/tools/post.sh >/dev/null 2>&1 &
  nohup /root/pear/tools/pear_one_minute_check.sh >/dev/null 2>&1 &
  nohup /root/pear/tools/pear_ten_minutes_check.sh >/dev/null 2>&1 &
  nohup /root/pear/tools/pear_debug.sh >/dev/null 2>&1 &
  nohup /root/pear/tools/install.sh >/dev/null 2>&1 &
  sed -i 's/sleep 5/sleep 20/g' /etc/rc.local
  ulimit -HSn 131072
  ulimit -c unlimited
}

stop_app() {
  killall -9 pear_restart
  sleep 2
  killall -9 pear_update
  killall -9 pear_monitor
  killall -9 pear_httpd
  killall -9 pear_s
  killall -9 socks_server
  killall -9 scan.sh
  killall -9 ksp2p-server
  killall -9 ks-agent
  killall -9 pear_findppp
  killall -9 install.sh
  killall -9 pear_one_minute_check.sh
  killall -9 pear_ten_minutes_check.sh
  killall -9 pear_debug.sh
  killall -9 ptty
  stop_all_groum_Guarded_by_pear_restart
}

case "$1" in
  start)
    stop_app
    start_app
    ;;
  stop)
    stop_app
    ;;
  reload|restart|force-reload)
    stop_app
    start_app
    ;;
  *)
    echo "$0 start|stop|reload|restart"
    exit 1
esac

exit 0
